   '***********************************************************************
   ' Autokrmika
   '
   ' v 0.5 (10.4.2018)           77% Flash used
   '
   ' Autor : Pavel Jank
   ' www.paja-trb.cz
   ' paja@paja-trb.cz
   '
   '***********************************************************************

$regfile = "m8def.dat"                                      'Soubor s deklaracemi - ATmega8
$crystal = 1000000                                          'Kmitoet osciltoru v Hz

Config Lcd = 16 * 2                                         'Typ LCD
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0       'Konfigurace pin LCD
Cursor Off

Declare Sub Klavesnice
Declare Sub Nastav_datum_cas
Declare Sub Cas_set
Declare Sub Datum
Declare Sub Nastav_alarm
Declare Sub Krmeni

Config Portb = Input
Config Portb.6 = Output                                     'piezo
Config Portb.7 = Output                                     'NC
Config Portc = Output
Config Portd = Output
Config Portd.6 = Input
Config Portd.7 = Input


Piezo Alias Portb.6 : Piezo = 0
Led Alias Portd.0                                           'podsviceni LCD
Motor Alias Portd.5 : Motor = 0


'Row1 Alias Portb.2      'radek
'Row2 Alias Portb.3
'Row3 Alias Portb.4
'Row4 Alias Portb.5
Col1 Alias Pind.6                                           'sloupec
Col2 Alias Pind.7
Col3 Alias Pinb.0
Col4 Alias Pinb.1
Set Portd.7 : Set Portd.6 : Set Portb.0 : Set Portb.1
Dim Key As Byte : Key = 16
Dim Key1 As Byte , Key2 As Byte , Key3 As Byte , Key4 As Byte , Key5 As Byte , Key6 As Byte , Key7 As Byte , Key8 As Byte , Key9 As Byte , Key10 As Byte
Dim Hod_al As Byte , Min_al As Byte , Cas_al As Byte
Dim Soucet As Word
Dim Cas As Byte : Cas = 0
Dim Chyba As Bit : Chyba = 0
Dim Pocet_zadani As Byte

' ------------- RTC --- DS3231 ------------------
Config Sda = Portd.4
Config Scl = Portd.3
Const Ds3231w = &B11010000                                  'write
Const Ds3231r = &B11010001                                  'read

'prvotni nastaveni SQW vstupu DS3231 na 1Hz
   I2cstart                                                 ' Generate start code
   I2cwbyte Ds3231w                                         ' send address
   I2cwbyte 14                                              ' starting address in 1307
   I2cwbyte &B00000000                                      ' SQWE - 1Hz(send Data To Control Register)
   I2cstop
   Waitms 10

'---------- ext. preruseni od RTC DS3231 - 1Hz ------------------
Config Pind.2 = Input : Set Portd.2                         'Ddrd.3 = 0   pin INT1 vstup ; pull-up
'Mcucr.isc00 = 1                                             'nastane pi zmn rovn na pinu INT0
Mcucr.isc01 = 1                                             'nastane pi klesajc hran na pinu INT0
Enable Int0                                                 'Konfigurace peruen INT0, od DS3231 - 1Hz
On Int0 Sekundovy_preruseni                                 'pi peruen sko na podprogram sekundovy_preruseni

Dim _sec As Byte , _min As Byte , _hod As Byte
Dim Weekday As Byte , Day As Byte , Month As Byte , Year As Byte

'eeprom - ulozena data alarmu A, B, C, D
Dim _hod_a As Eram Byte At 1 , _min_a As Eram Byte At 2 , Cas_a As Eram Byte At 3
Dim _hod_b As Eram Byte At 4 , _min_b As Eram Byte At 5 , Cas_b As Eram Byte At 6
Dim _hod_c As Eram Byte At 7 , _min_c As Eram Byte At 8 , Cas_c As Eram Byte At 9
Dim _hod_d As Eram Byte At 10 , _min_d As Eram Byte At 11 , Cas_d As Eram Byte At 12

Enable Interrupts

Set Led                                                     'zapni podsviceni
Cls
Locate 1 , 1 : Lcd "Autokrmicka v0.5"
Locate 2 , 1 : Lcd "PaJa-trb    2018"
Wait 1

'jedine po zapnut je mozno vyvolat menu nastaveni data a casu
Call Klavesnice
If Key = 11 Then Call Nastav_datum_cas                      '#
Wait 1

Cls
Reset Led

'================================= START ============================================

Do

If Pind.2 = 0 Then
   Locate 1 , 1 : Lcd Day ; "." ; Month ; ".20" ; Year ; "    "
   Locate 2 , 1 : Lcd _hod ; ":" ; _min ; ":" ; _sec ; "   "
End If

Call Klavesnice

Select Case Key
   Case 10 : Reset Led                                      '* - zhasni displej
   Case 11 : Set Led                                        '# - rozsvit displej
   Case 12:                                                 'A - cas krmeni
            Locate 1 , 16 : Lcd "A"
            Hod_al = _hod_a
            Min_al = _min_a
            Cas_al = Cas_a
            Call Nastav_alarm
            _hod_a = Key1
            _min_a = Key2
            Cas_a = Key3
   Case 13:                                                 'B
            Locate 1 , 16 : Lcd "B"
            Hod_al = _hod_b
            Min_al = _min_b
            Cas_al = Cas_b
            Call Nastav_alarm
            _hod_b = Key1
            _min_b = Key2
            Cas_b = Key3
   Case 14:                                                 'C
            Locate 1 , 16 : Lcd "C"
            Hod_al = _hod_c
            Min_al = _min_c
            Cas_al = Cas_c
            Call Nastav_alarm
            _hod_c = Key1
            _min_c = Key2
            Cas_c = Key3
   Case 15:
            Locate 1 , 16 : Lcd "D"                         'D
            Hod_al = _hod_d
            Min_al = _min_d
            Cas_al = Cas_d
            Call Nastav_alarm
            _hod_d = Key1
            _min_d = Key2
            Cas_d = Key3
End Select

'kdyz je cas z RTCa cas ulozeneho alarmu stejny, tak zavolej krmeni
If _hod_a = _hod And _min_a = _min And _sec = 0 Then
   Key10 = Cas_a
   Locate 2 , 16 : Lcd "A"
   Call Krmeni
End If

If _hod_b = _hod And _min_b = _min And _sec = 0 Then
   Key10 = Cas_b
   Locate 2 , 16 : Lcd "B"
   Call Krmeni
End If

If _hod_c = _hod And _min_c = _min And _sec = 0 Then
   Key10 = Cas_c
   Locate 2 , 16 : Lcd "C"
   Call Krmeni
End If

If _hod_d = _hod And _min_d = _min And _sec = 0 Then
   Key10 = Cas_d
   Locate 2 , 16 : Lcd "D"
   Call Krmeni
End If

   Waitms 50


Loop

End

'================================= Konec ============================================

'-------------------------------------------------------------------------------
'1x za sekundu (1Hz) nacti data z RTC - preruseni od pinu SQWE - klesajici hrana
Sekundovy_preruseni:

           I2cstart                                         ' Generate start code
           I2cwbyte Ds3231w                                 ' send address
           I2cwbyte 0                                       ' start address in DS3231
           I2cstart                                         ' Generate start code
           I2cwbyte Ds3231r                                 ' send address
           I2crbyte _sec , Ack                              ' sec
           I2crbyte _min , Ack                              ' MINUTES
           I2crbyte _hod , Ack                              ' Hours
           I2crbyte Weekday , Ack                           ' WEEK DAY - nepouzito
           I2crbyte Day , Ack                               ' DAY
           I2crbyte Month , Ack                             ' MONTH
           I2crbyte Year , Nack                             ' YEAR
           I2cstop

           _sec = Makedec(_sec) : _min = Makedec(_min) : _hod = Makedec(_hod)       'preved nactena data na Dec
           Day = Makedec(day) : Month = Makedec(month) : Year = Makedec(year)

Return

'-------------------------------------------------------------------------------

Sub Krmeni
   Set Led
   Set Piezo : Waitms 10 : Reset Piezo
   Motor = 1 : Led = 0                                      'zapni motor, zhasni LED

Do
   If Pind.2 = 0 Then                                       'sekundovy impulz od RTC 1Hz
      Decr Key10                                            'kazdy impuzlz 1Hz odecti 1 sekundu
      Led = 0
   Else
      Led = 1
   End If

   Bitwait Pind.2 , Set                                     'pockej na preklopeni sekund na log.1
   Locate 1 , 1 : Lcd "Krmim, cas:" ; Key10 ; "[s]  "       'odpocet casu na LCD
   Locate 2 , 1 : Lcd _hod ; ":" ; _min ; ":" ; _sec ; "    "

Loop Until Key10 = 0                                        'cas vyprsel, konec

   Motor = 0 : Led = 0 : Cls                                'vypni motor, zhasni LED, smaz LCD

End Sub

'-------------------------------------------------------------------------------

Sub Nastav_datum_cas
Set Led
Disable Int0

Key1 = 0 : Key2 = 1 : Key3 = 0 : Key4 = 1 : Key5 = 1 : Key6 = 7 : Key7 = 0 : Key8 = 0 : Key9 = 0 : Key10 = 0 : Pocet_zadani = 0 : Chyba = 0
Locate 1 , 1 : Lcd "Den mesic rok   "
Locate 2 , 1 : Lcd "dd.mm.20rr/hh:mm"
Wait 1
Cls

Do
Locate 1 , 1 : Lcd Day ; "." ; Month ; ".20" ; Year ; "/" ; _hod ; ":" ; _min ; "     "


Call Klavesnice

If Key = 10 And Pocet_zadani > 0 Then Pocet_zadani = Pocet_zadani - 1       '* mazani

     Locate 2 , 1
     Select Case Pocet_zadani
       Case 0 : Lcd "        "
       Case 1 : Lcd Key1 ; "        "
       Case 2 :
                Lcd Key1 ; Key2 ; ".       "
       Case 3 :
                Lcd Key1 ; Key2 ; "." ; Key3 ; "        "
       Case 4 :
                Lcd Key1 ; Key2 ; "." ; Key3 ; Key4 ; ".20     "
       Case 5 :
                Lcd Key1 ; Key2 ; "." ; Key3 ; Key4 ; ".20" ; Key5 ; "       "
       Case 6 :
                Lcd Key1 ; Key2 ; "." ; Key3 ; Key4 ; ".20" ; Key5 ; Key6 ; "/     "
       Case 7 :
                Lcd Key1 ; Key2 ; "." ; Key3 ; Key4 ; ".20" ; Key5 ; Key6 ; "/" ; Key7 ; "   "
       Case 8 :
                Lcd Key1 ; Key2 ; "." ; Key3 ; Key4 ; ".20" ; Key5 ; Key6 ; "/" ; Key7 ; Key8 ; ":   "
       Case 9 :
                Lcd Key1 ; Key2 ; "." ; Key3 ; Key4 ; ".20" ; Key5 ; Key6 ; "/" ; Key7 ; Key8 ; ":" ; Key9 ; " "
       Case 10 :
                Lcd Key1 ; Key2 ; "." ; Key3 ; Key4 ; ".20" ; Key5 ; Key6 ; "/" ; Key7 ; Key8 ; ":" ; Key9 ; Key10
     End Select

  If Key < 10 And Pocet_zadani < 10 Then                    'je-li stisknuta klavesa 0-9 a pocet_zadani mensi jak 6
     Incr Pocet_zadani

     Select Case Pocet_zadani
       Case 1 : Key1 = Key
       Case 2 : Key2 = Key
       Case 3 : Key3 = Key
       Case 4 : Key4 = Key
       Case 5 : Key5 = Key
       Case 6 : Key6 = Key
       Case 7 : Key7 = Key
       Case 8 : Key8 = Key
       Case 9 : Key9 = Key
       Case 10 : Key10 = Key
     End Select
  End If

Day = Key1 * 10
Day = Day + Key2
If Day > 31 Or Day = 0 Then
   Key1 = 0 : Key2 = 1 : Pocet_zadani = 0 : Chyba = 1
End If

Month = Key3 * 10
Month = Month + Key4
If Month > 12 Or Month = 0 Then
   Key3 = 0 : Key4 = 1 : Pocet_zadani = 2 : Chyba = 1
End If

Year = Key5 * 10
Year = Year + Key6
If Year > 99 Then
   Key5 = 1 : Key6 = 7 : Pocet_zadani = 4 : Chyba = 1
End If

_hod = Key7 * 10
_hod = _hod + Key8
If _hod > 23 Then
   Key7 = 0 : Key8 = 0 : Pocet_zadani = 6 : Chyba = 1
End If

_min = Key9 * 10
_min = _min + Key10
If _min > 59 Then
   Key9 = 0 : Key10 = 0 : Pocet_zadani = 8 : Chyba = 1
End If

If Chyba = 1 Then
   Locate 2 , 1 : Lcd "Chyba - znovu   "
   Set Piezo : Waitms 50 : Reset Piezo
   Wait 1
   Cls
   Chyba = 0
End If

Loop Until Key = 11                                         '# konec Enter

Waitms 100

'uloz datum a cas do RTC
Call Datum
Call Cas_set

Enable Int0

Reset Led
End Sub

'-------------------------------------------------------------------------------

'-------------------------------------------------------------------------------

Sub Nastav_alarm
Set Led
Disable Int0

Key1 = 0 : Key2 = 0 : Key3 = 0 : Key4 = 0 : Key5 = 0 : Key6 = 1 : Pocet_zadani = 0 : Chyba = 0
Locate 1 , 1 : Lcd "hh:mm, doba[s] "                        '+A, B, C, D
Wait 1

'zobrazeni ulozenych hodnot casu
Locate 1 , 1 : Lcd Hod_al ; ":" ; Min_al ; ", " ; Cas_al ; "[s] "

Do
Call Klavesnice

If Key = 10 And Pocet_zadani > 0 Then Pocet_zadani = Pocet_zadani - 1       '* mazani

     Locate 2 , 1
     Select Case Pocet_zadani
       Case 0 : Lcd "              "
       Case 1 : Lcd Key1 ; "            "
       Case 2 :
                Lcd Key1 ; Key2 ; ":       "
       Case 3 :
                Lcd Key1 ; Key2 ; ":" ; Key3 ; "        "
       Case 4 :
                Lcd Key1 ; Key2 ; ":" ; Key3 ; Key4 ; ",     "
       Case 5 :
                Lcd Key1 ; Key2 ; ":" ; Key3 ; Key4 ; ", " ; Key5 ; " [s]      "
       Case 6 :
                Lcd Key1 ; Key2 ; ":" ; Key3 ; Key4 ; ", " ; Key5 ; Key6 ; "[s]    "
     End Select

  If Key < 10 And Pocet_zadani < 6 Then                     'je-li stisknuta klavesa 0-9 a pocet_zadani mensi jak 6
     Incr Pocet_zadani

     Select Case Pocet_zadani
       Case 1 : Key1 = Key
       Case 2 : Key2 = Key
       Case 3 : Key3 = Key
       Case 4 : Key4 = Key
       Case 5 : Key5 = Key
       Case 6 : Key6 = Key
     End Select
  End If

_hod = Key1 * 10
_hod = _hod + Key2
If _hod > 23 Then
   Key1 = 0 : Key2 = 0 : Pocet_zadani = 0 : Chyba = 1
End If

_min = Key3 * 10
_min = _min + Key4
If _min > 59 Then
   Key3 = 0 : Key4 = 0 : Pocet_zadani = 2 : Chyba = 1
End If

_sec = Key5 * 10
_sec = _sec + Key6
If Cas > 59 Or _sec = 0 Then
   Key5 = 0 : Key6 = 1 : Pocet_zadani = 4 : Chyba = 1
End If

If Chyba = 1 Then
   Locate 2 , 1 : Lcd "Chyba - znovu   "
   Set Piezo : Waitms 50 : Reset Piezo
   Wait 1
   Chyba = 0
End If


Loop Until Key = 11                                         '# konec Enter

Key1 = _hod
Key2 = _min
Key3 = _sec

Cls
Waitms 100

Enable Int0
Reset Led

End Sub


'-------------------------------------------------------------------------------

Sub Datum
         Day = Makebcd(day)
         Month = Makebcd(month)
         Year = Makebcd(year)
         I2cstart                                           ' Generate start code
         I2cwbyte Ds3231w                                   ' send address
         I2cwbyte 4                                         ' starting address in3231
         I2cwbyte Day                                       ' DAY
         I2cwbyte Month                                     ' MONTH
         I2cwbyte Year                                      ' YERS
         I2cstop
End Sub

'-------------------------------------------------------------------------------
Sub Cas_set                                                 'hodiny, minuty a 0 sekund zapis do DS3231
         _min = Makebcd(_min)
         _hod = Makebcd(_hod)
         I2cstart                                           ' Generate start code
         I2cwbyte Ds3231w                                   ' send address
         I2cwbyte 0                                         ' starting address in 3231
         I2cwbyte 0                                         ' Send Data to SECONDS = 0
         I2cwbyte _min                                      ' Send Data to MINUTES
         I2cwbyte _hod
         I2cstop
End Sub

'-------------------------------------------------------------------------------


Sub Klavesnice
  Key = 16                                                  'odpovez ze nebylo nic stisknuto
  Ddrd = &B00100011                                         'PortD.7-6, 4-2 In
  Ddrb = &B11111100                                         'PortB.0-1 In
  Waitms 150
  Portb.5 = 0                                               'PortB.5=0  -> Row4=0
  If Col1 = 0 Then Key = 12                                 'A
  If Col2 = 0 Then Key = 3
  If Col3 = 0 Then Key = 2
  If Col4 = 0 Then Key = 1
  Portb.5 = 1
  Waitms 2
  Portb.4 = 0                                               'PortB.4=0  -> Row3=0
  If Col1 = 0 Then Key = 13                                 'B
  If Col2 = 0 Then Key = 6
  If Col3 = 0 Then Key = 5
  If Col4 = 0 Then Key = 4
  Portb.4 = 1
  Waitms 2
  Portb.3 = 0                                               'PortB.3=0  -> Row2=0
  If Col1 = 0 Then Key = 14                                 'C
  If Col2 = 0 Then Key = 9
  If Col3 = 0 Then Key = 8
  If Col4 = 0 Then Key = 7
  Portb.3 = 1
  Waitms 2
  Portb.2 = 0                                               'PortB.2=0  -> Row1=0
  If Col1 = 0 Then Key = 15                                 'D
  If Col2 = 0 Then Key = 11                                 '#
  If Col3 = 0 Then Key = 0
  If Col4 = 0 Then Key = 10                                 '*
  Portb.2 = 1
  Waitms 2
'A=12, B=13, C=14, D=15, *=10, #=11
End Sub

'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------

' Copyright (C) PaJa-trb 2017-2018